package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingCorridaDAO;
import com.rjconsultores.ventaboletos.entidad.CorridaCtrl;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingCorrida;
import com.rjconsultores.ventaboletos.service.GP_PricingCorridaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingCorridaService")
public class GP_PricingCorridaServiceImpl implements GP_PricingCorridaService {

    @Autowired
    private GP_PricingCorridaDAO pricingCorridaDAO;

    public List<GP_PricingCorrida> obtenerTodos() {
        return pricingCorridaDAO.obtenerTodos();
    }

    public GP_PricingCorrida obtenerID(Integer id) {
        return pricingCorridaDAO.obtenerID(id);
    }

    @Transactional
    public GP_PricingCorrida suscribir(GP_PricingCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingCorridaDAO.suscribir(entidad);
    }

    @Transactional
    public GP_PricingCorrida actualizacion(GP_PricingCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingCorridaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(GP_PricingCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.EXCLUIDO);

        pricingCorridaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingCorrida(GP_Pricing pricing, CorridaCtrl corrida) {
        return pricingCorridaDAO.obtenerPricingCorrida(pricing, corrida);
    }

	@Override
	public List<GP_PricingCorrida> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingCorridaDAO.obtenerTodoPorPricing(pricing);
	}
}
